
declare var famous: any;

import {
Component,
View,
Host,
onInit,
onChange
} from 'angular2/angular2';

import {FaNode} from '../core/node';

// FaDomElement

@Component({
  selector: 'fa-element',
  properties: ['properties', 'attr', 'content', 'id', 'classes']
})

@View({
  template: ``
})

export class FaDomElement {
  id: String;
  classes: Array<String>[];
  element: any;
  attr: any;
  properties: Object;
  attributes: Object;
  content: String;
  constructor(@Host() parent:FaNode) {

    var DOMElement = famous.domRenderables.DOMElement;
          // add an element
    this.element = new DOMElement(parent.node);

  }

  setClasses(classes) {
      for(let i=0; i<classes.length; i++){
          if(!this.element.hasClass(classes[i])){
              this.element.addClass(classes[i]);
          }
      }
  }

  setProperties(prop) {
    if(prop){
        for (let key in prop) {
            if (prop.hasOwnProperty(key)) {
                 this.element.setProperty(key.replace(/([a-z])([A-Z])/g, '$1-$2').toLowerCase(),prop[key]);
            }
        }
    }
  }

  setAttributes(attr) {
    if(attr){
        for (let key in attr) {
            if (attr.hasOwnProperty(key)) {
                this.element.setAttribute(key,attr[key]);
            }
        }
    }
  }

  onInit() {

    let elem = this;
    this.content ? this.element.setContent(elem.content) : false;
    this.id ? this.element.setId(this.id) : false;
    this.classes ? this.setClasses(this.classes): false;
    this.attr ? this.setAttributes(this.attr) : false;
    this.properties ? this.setProperties(this.properties) : false;

  }

}
